//
//  AppDelegate.m
//  BackgroundFetchTutorial
//
//  Created by MI-MAC01 on 9/23/14.
//  Copyright (c) 2014 Mobisoft. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate
@synthesize updateTimer = _updateTimer;
@synthesize viewController = _viewController;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
    
    // Set Minimum Background Fetch Inteval //
    if(SYSTEM_VERSION_GREATER_THAN_OR_EQUAL_TO(@"7.0"))
    {
        [[UIApplication sharedApplication]
         setMinimumBackgroundFetchInterval:
         UIApplicationBackgroundFetchIntervalMinimum];
    }
    
    // Initialize ViewController //
    [self initializeViewController];
    
    return YES;
}
							
- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    
    if(self.backgroundTask == UIBackgroundTaskInvalid)
    {
        [_viewController fetchTemperature];
    }
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

-(void) invalidateUpdateTimer
{
    if(_updateTimer)
    {
        [_updateTimer invalidate];
        
        _updateTimer = nil;
    }
}

-(void) initializeViewController
{
    _viewController = [[ViewController alloc] init];
}

-(void) beginBackgroundUploadTask
{
    if(self.backgroundTask != UIBackgroundTaskInvalid)
    {
        [self endBackgroundUploadTask];
    }
    
    self.backgroundTask = [[UIApplication sharedApplication] beginBackgroundTaskWithExpirationHandler:^{
        
        DebugLog(@"Background Time:%f",[[UIApplication sharedApplication] backgroundTimeRemaining]);
        
        [self invalidateUpdateTimer];
        
        [self endBackgroundUploadTask];
        
    }];
}

-(void) endBackgroundUploadTask
{
    [[UIApplication sharedApplication] endBackgroundTask:self.backgroundTask];
    self.backgroundTask = UIBackgroundTaskInvalid;
}

-(void)application:(UIApplication *)application performFetchWithCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler
{
    DebugLog(@"Fetched New Data");
    
    DebugLog(@"Background time Remaining: %f",[[UIApplication sharedApplication] backgroundTimeRemaining]);
    
    if(self.backgroundTask == UIBackgroundTaskInvalid)
    {
        [self beginBackgroundUploadTask];
        
        [_viewController fetchTemperature];
    }
    completionHandler(UIBackgroundFetchResultNewData);
}

@end
